/* Virginia Tech Cognitive Radio Open Source Systems
 * Virginia Tech, 2009
 *
 * LICENSE INFORMATION GOES HERE
 */

/* This header contains commonly used data container structs in VT-CROSS
 * systems.
 */

#ifndef CONTAINERS_H
#define CONTAINERS_H


#include <stdint.h>


/* TODO
 *
 */
struct CE_Info {
    uint32_t numUtilities;
    uint32_t numParameters;
    uint32_t numObservables;
    uint32_t policy_engine;
    uint32_t policy_socket;
    uint32_t ce_socket;
};


/* TODO
 *
 */
struct Utility {
    char* name;
    char* units;
    char* goal;
    float target;
    float value;
};


/* TODO
 *
 */
struct Affect {
    Utility *u;
    char* relation;
};


/* TODO
 *
 */
struct Parameter {
    char* name;
    char* units;
    float min;
    uint32_t numAffects;
    Affect affection_list[10];
    float max;
    float step;
    float value;
};


/* TODO
 *
 */
struct Observable {
    char* name;
    Affect affection_list[10];
    uint32_t numAffects;
    float value;
};

#endif
